Merge trunk version 195707 into gupc branch.
[official-gcc.git] / contrib / gcc_update
blob26e541805a707744830094585a5923a7189e34ef
1 #! /bin/sh
3 # Update a local Subversion, Git or Mercurial tree from the GCC
4 # repository, with an emphasis on treating generated files correctly, so
5 # that autoconf, gperf et al are not required for the ``end'' user.
7 # (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009, 2010,
8 # 2011 Free Software Foundation
9 # Originally by Gerald Pfeifer <pfeifer@dbai.tuwien.ac.at>, August 1998.
11 # This script is Free Software, and it can be copied, distributed and
12 # modified as defined in the GNU General Public License. A copy of
13 # its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
16 # By default all command-line options are passed to `svn update` or `hg/git
17 # pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
18 # reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
19 # are omitted.
21 # If the first parameter reads --patch, the second parameter is considered
22 # a patch file.
24 # If the first parameter is --touch, no svn operation will be performed,
25 # only generated files that appear to be out of date in the local tree
26 # will be touched.
28 # If the first parameter is --list, a list of the generated files and
29 # their dependencies will be printed; --help prints this message.
31 # If the first parameter is --silent, this script prints nothing other
32 # than error messages; the second parameter is then interpreted as above.
34 # Examples:
36 # contrib/gcc_update -r 8712
37 # contrib/gcc_update --patch some-patch
38 # contrib/gcc_update --touch
39 # contrib/gcc_update --list
42 # Default options used when updating (none).
43 UPDATE_OPTIONS=""
45 # Set the locale to C to make this script work for users with foreign
46 # locale like e.g. French UTF-8.
47 LANG=C
48 LC_ALL=C
49 export LANG LC_ALL
51 ######## Anything below shouldn't be changed by regular users.
53 # Arrange for the value of $0 to be available for functions
54 self=$0
56 # This function prints its arguments to standard output unless
57 # "silent" is set.
58 unset silent
59 chat () {
60 if [ -z "$silent" ]; then
61 echo "$@"
65 # This function prints a list of all generated files, along with their
66 # dependencies. Note that only one target is supported per line: the
67 # colon is stripped from the output.
68 files_and_dependencies () {
69 sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
70 # fixincludes
71 fixincludes/configure: fixincludes/configure.ac fixincludes/aclocal.m4
72 fixincludes/config.h.in: fixincludes/configure.ac fixincludes/aclocal.m4
73 # intl library
74 intl/plural.c: intl/plural.y
75 intl/configure: intl/configure.ac intl/aclocal.m4
76 intl/config.h.in: intl/configure.ac intl/aclocal.m4
77 # Now, proceed to gcc automatically generated files
78 gcc/configure: gcc/configure.ac
79 gcc/cstamp-h.in: gcc/configure.ac
80 gcc/config.in: gcc/cstamp-h.in
81 gcc/fixinc/fixincl.x: gcc/fixinc/fixincl.tpl gcc/fixinc/inclhack.def
82 gcc/config/arm/arm-tune.md: gcc/config/arm/arm-cores.def gcc/config/arm/gentune.sh
83 gcc/config/arm/arm-tables.opt: gcc/config/arm/arm-arches.def gcc/config/arm/arm-cores.def gcc/config/arm/arm-fpus.def gcc/config/arm/genopt.sh
84 gcc/config/avr/avr-tables.opt: gcc/config/avr/avr-mcus.def gcc/config/avr/genopt.sh
85 gcc/config/avr/t-multilib: gcc/config/avr/avr-mcus.def gcc/config/avr/genmultilib.awk
86 gcc/config/c6x/c6x-tables.opt: gcc/config/c6x/c6x-isas.def gcc/config/c6x/genopt.sh
87 gcc/config/c6x/c6x-sched.md: gcc/config/c6x/c6x-sched.md.in gcc/config/c6x/gensched.sh
88 gcc/config/c6x/c6x-mult.md: gcc/config/c6x/c6x-mult.md.in gcc/config/c6x/genmult.sh
89 gcc/config/m68k/m68k-tables.opt: gcc/config/m68k/m68k-devices.def gcc/config/m68k/m68k-isas.def gcc/config/m68k/m68k-microarchs.def gcc/config/m68k/genopt.sh
90 gcc/config/mips/mips-tables.opt: gcc/config/mips/mips-cpus.def gcc/config/mips/genopt.sh
91 gcc/config/rs6000/rs6000-tables.opt: gcc/config/rs6000/rs6000-cpus.def gcc/config/rs6000/genopt.sh
92 gcc/config/tilegx/mul-tables.c: gcc/config/tilepro/gen-mul-tables.cc
93 gcc/config/tilepro/mul-tables.c: gcc/config/tilepro/gen-mul-tables.cc
94 # And then, language-specific files
95 gcc/cp/cfns.h: gcc/cp/cfns.gperf
96 gcc/java/keyword.h: gcc/java/keyword.gperf
97 # testsuite
98 # Without this, _Pragma3.c can have a false negative.
99 gcc/testsuite/gcc.dg/cpp/_Pragma3.c: gcc/testsuite/gcc.dg/cpp/mi1c.h
100 # Similarly, without this, you will see:
101 # direct2s.c:35: warning: current file is older than direct2.c
102 gcc/testsuite/gcc.dg/cpp/direct2s.c: gcc/testsuite/gcc.dg/cpp/direct2.c
103 # lto-plugin
104 lto-plugin/configure: lto-plugin/configure.ac lto-plugin/aclocal.m4
105 lto-plugin/Makefile.in: lto-plugin/Makefile.am lto-plugin/aclocal.m4
106 # And libraries, at last
107 libbanshee/configure: libbanshee/configure.ac
108 libmudflap/configure: libmudflap/configure.ac
109 libobjc/configure: libobjc/configure.ac
110 zlib/aclocal.m4: zlib/configure.ac zlib/acinclude.m4
111 zlib/Makefile.in: zlib/Makefile.am zlib/configure.ac zlib/aclocal.m4
112 zlib/configure: zlib/configure.ac zlib/aclocal.m4
113 fastjar/aclocal.m4: fastjar/configure.ac
114 fastjar/Makefile.in: fastjar/Makefile.am fastjar/configure.ac fastjar/aclocal.m4
115 fastjar/configure: fastjar/configure.ac fastjar/aclocal.m4
116 boehm-gc/aclocal.m4: boehm-gc/configure.ac
117 boehm-gc/Makefile.in: boehm-gc/Makefile.am boehm-gc/configure.ac boehm-gc/aclocal.m4
118 boehm-gc/configure: boehm-gc/configure.ac boehm-gc/aclocal.m4
119 libada/configure: libada/configure.ac
120 libffi/aclocal.m4: libffi/configure.ac libffi/acinclude.m4
121 libffi/Makefile.in: libffi/Makefile.am libffi/configure.ac libffi/aclocal.m4
122 libffi/configure: libffi/configure.ac libffi/aclocal.m4
123 libffi/fficonfig.h.in: libffi/configure.ac libffi/aclocal.m4
124 libgfortran/aclocal.m4: libgfortran/configure.ac libgfortran/acinclude.m4
125 libgfortran/Makefile.in: libgfortran/Makefile.am libgfortran/configure.ac libgfortran/aclocal.m4
126 libquadmath/configure: libquadmath/configure.ac libquadmath/aclocal.m4
127 libquadmath/aclocal.m4: libquadmath/configure.ac libquadmath/acinclude.m4
128 libquadmath/Makefile.in: libquadmath/Makefile.am libquadmath/configure.ac libgfortran/aclocal.m4
129 libgfortran/configure: libgfortran/configure.ac libgfortran/aclocal.m4
130 libjava/aclocal.m4: libjava/configure.ac
131 libjava/Makefile.in: libjava/Makefile.am libjava/configure.ac libjava/aclocal.m4
132 libjava/configure: libjava/configure.ac libjava/aclocal.m4
133 libjava/libltdl/aclocal.m4: libjava/libltdl/configure.ac libjava/libltdl/acinclude.m4
134 libjava/libltdl/Makefile.in: libjava/libltdl/Makefile.am libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
135 libjava/libltdl/configure: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
136 libjava/libltdl/config-h.in: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
137 libcpp/aclocal.m4: libcpp/configure.ac
138 libcpp/Makefile.in: libcpp/configure.ac libcpp/aclocal.m4
139 libcpp/configure: libcpp/configure.ac libcpp/aclocal.m4
140 libgomp/aclocal.m4: libgomp/configure.ac libgomp/acinclude.m4
141 libgomp/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
142 libgomp/testsuite/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
143 libgomp/configure: libgomp/configure.ac libgomp/aclocal.m4
144 libgomp/config.h.in: libgomp/configure.ac libgomp/aclocal.m4
145 libgupc/aclocal.m4: libgupc/configure.ac libgupc/acinclude.m4
146 libgupc/config.h.in: libgupc/configure.ac
147 libgupc/configure: libgupc/configure.ac libgupc/aclocal.m4 libgupc/acinclude.m4
148 libgupc/Makefile.in: libgupc/Makefile.am libgupc/aclocal.m4
149 libgupc/testsuite/Makefile.in: libgupc/Makefile.am libgupc/aclocal.m4
150 libitm/aclocal.m4: libitm/configure.ac libitm/acinclude.m4
151 libitm/Makefile.in: libitm/Makefile.am libitm/aclocal.m4
152 libitm/testsuite/Makefile.in: libitm/testsuite/Makefile.am libitm/aclocal.m4
153 libitm/configure: libitm/configure.ac libitm/aclocal.m4
154 libitm/config.h.in: libitm/configure.ac libitm/aclocal.m4
155 libatomic/aclocal.m4: libatomic/configure.ac libatomic/acinclude.m4
156 libatomic/Makefile.in: libatomic/Makefile.am libatomic/aclocal.m4
157 libatomic/testsuite/Makefile.in: libatomic/testsuite/Makefile.am libatomic/aclocal.m4
158 libatomic/configure: libatomic/configure.ac libatomic/aclocal.m4
159 libatomic/auto-config.h.in: libatomic/configure.ac libatomic/aclocal.m4
160 libsanitizer/aclocal.m4: libsanitizer/configure.ac libsanitizer/acinclude.m4
161 libsanitizer/Makefile.in: libsanitizer/Makefile.am libsanitizer/aclocal.m4
162 libsanitizer/configure: libsanitizer/configure.ac libsanitizer/aclocal.m4
163 libsanitizer/asan/Makefile.in: libsanitizer/asan/Makefile.am libsanitizer/aclocal.m4
164 libsanitizer/interception/Makefile.in: libsanitizer/interception/Makefile.am libsanitizer/aclocal.m4
165 libsanitizer/sanitizer_common/Makefile.in: libsanitizer/sanitizer_common/Makefile.am libsanitizer/aclocal.m4
166 # Top level
167 Makefile.in: Makefile.tpl Makefile.def
168 configure: configure.ac config/acx.m4
173 # This function touches generated files such that the ``end'' user does
174 # not have to rebuild them.
175 touch_files () {
176 rm -f Makefile.$$
177 echo 'all: \' > Makefile.$$
178 files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
179 echo '; @true' >> Makefile.$$
180 files_and_dependencies | sed 's, ,: ,' >> Makefile.$$
181 files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
182 echo ':' >> Makefile.$$
183 echo ' @for f in $? $@; do test -f $$f || exit 0; done; \' >> Makefile.$$
184 echo ' echo Touching $@...; \' >> Makefile.$$
185 chat ' echo Touching $@... 1>&2; \' >> Makefile.$$
186 echo ' touch $@' >> Makefile.$$
187 files_and_dependencies | sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
189 # We would have to explicitly shut off the "Entering... Leaving..."
190 # messages through "--no-print-directory" to handle the case when
191 # we were called from a recursive invocation (i.e. "$(MAKE)" in a
192 # Makefile, not just make). Passing only "-s" doesn't help then,
193 # because make has helpfully added "-w" to MAKEFLAGS automatically.
194 # Unfortunately we do not require GNU make other than for building
195 # and testing, so let's just grep known text explicitly echoed by
196 # the rule.
197 while ${MAKE-make} -s -f Makefile.$$ all | grep Touching > /dev/null; do
198 sleep 1
199 done 2>&1
200 rm -f Makefile.$$
204 # Whenever we update the tree or install a patch, we may be modifying
205 # this script. By re-execing it, we ensure that the appropriate
206 # dependencies and rules will be used.
207 touch_files_reexec () {
208 chat "Adjusting file timestamps"
209 exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
212 # This functions applies a patch to an existing tree.
213 apply_patch () {
214 if [ -f "$1" ]; then
215 echo "Applying patch file $1"
216 case $1 in
217 *gz)
218 gzip -d -c "$1" | patch -p1 ;;
219 *bz2)
220 bzip2 -d -c "$1" | patch -p1 ;;
222 patch -p1 < "$1";;
223 esac
225 touch_files_reexec
228 # Check whether this indeed looks like a local tree.
229 if [ ! -f gcc/version.c ]; then
230 echo "This does not seem to be a GCC tree!"
231 exit
234 case "$1" in
235 --silent)
236 silent=t
237 shift
239 esac
241 case "$1" in
242 # First of all, check whether we are going to process a patch.
243 --patch)
244 if test "$#" != 2; then
245 echo "$1" expects only one argument >&2
246 exit 1
248 apply_patch "${2}"
249 exit $?
252 --touch)
253 if test "$#" != 1; then
254 echo "$1" does not expect any argument >&2
255 exit 1
257 touch_files
258 exit $?
261 --list)
262 if test "$#" != 1; then
263 echo "$1" does not expect any argument >&2
264 exit 1
266 files_and_dependencies | sed 's/ /: /'
267 exit $?
270 --help)
271 sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
275 }' \
276 -e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
277 exit $?
280 esac
282 # Check for known version control systems.
283 if [ -d .git ]; then
284 GCC_GIT=${GCC_GIT-${GIT-git}}
285 vcs_type="git"
286 elif [ -d .hg ]; then
287 GCC_HG=${GCC_HG-${HG-hg}}
288 vcs_type="hg"
289 elif [ -d .svn ]; then
290 GCC_SVN=${GCC_SVN-${SVN-svn}}
291 vcs_type="svn"
292 else
293 echo "This does not seem to be a GCC GIT/HG/SVN tree!"
294 exit
297 # Check command-line options
298 if [ x"${1}"x = x"--nostdflags"x ]; then
299 shift
300 else
301 set -- $UPDATE_OPTIONS ${1+"$@"}
304 case $vcs_type in
305 git)
306 chat "Updating GIT tree"
308 $GCC_GIT diff --quiet --exit-code HEAD
309 if [ $? -ne 0 ]; then
310 echo "Attempting to update a dirty git tree!" >&2
311 echo "Commit or stash your changes first and retry." >&2
312 exit 1
315 $GCC_GIT pull ${silent+-q} --rebase ${1+"$@"}
316 if [ $? -ne 0 ]; then
317 (touch_files_reexec)
318 echo "git pull of full tree failed." >&2
319 exit 1
322 revision=`$GCC_GIT log -n1 --pretty=%p:%t:%H`
323 branch=`$GCC_GIT name-rev --name-only HEAD || :`
327 chat "Updating HG tree"
329 # Add -q so untracked files aren't listed.
330 if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
331 echo "Attempting to update a dirty hg tree!" >&2
332 echo "Commit or revert your changes first and retry." >&2
333 exit 1
336 # Check for mq extension. mq patches must be popped so tip has
337 # been converted from the SVN tree.
338 if [ -d .hg/patches ] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
339 # FIXME: Perhaps pop queue instead? We could do that since we
340 # know the tree is clean.
341 echo "Attempting to update hg tree with mq patches applied!" >&2
342 echo "Pop your patches first and retry." >&2
343 exit 1
346 # Update tree, but make sure to only pull the default branch.
347 # Otherwise all branches in the upstream repo are added, even if
348 # only a single one has been cloned.
349 $GCC_HG pull ${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
350 if [ $? -ne 0 ]; then
351 (touch_files_reexec)
352 echo "hg pull of full tree failed." >&2
353 exit 1
356 # Update tree. Needs to be done separately from pull so
357 # gcc_update -rREV works.
358 $GCC_HG update ${silent+-q} ${1+"$@"}
359 if [ $? -ne 0 ]; then
360 (touch_files_reexec)
361 echo "hg update of full tree failed." >&2
362 exit 1
365 # Extract SVN revision corresponding to parents, as stored by
366 # hg convert. Before hg 1.4.3, there's no template keyword
367 # corresponding to the extra: tag, so need to use hg log --debug
368 # to extract the info.
369 parents=`$GCC_HG parents --template '{rev}'`
370 convert_revision=`$GCC_HG log --debug -r$parents | \
371 sed -ne "/^extra:.*convert_revision=svn:/ {
372 s%^[^/]*/%%
375 revision=`echo $convert_revision | sed -e 's/.*@//'`
376 branch=`echo $convert_revision | sed -e 's%branches/%%' -e 's/@.*//'`
379 svn)
380 chat "Updating SVN tree"
382 $GCC_SVN ${silent+-q} --non-interactive update ${1+"$@"}
383 if [ $? -ne 0 ]; then
384 (touch_files_reexec)
385 echo "SVN update of full tree failed." >&2
386 exit 1
389 revision=`$GCC_SVN info | awk '/Revision:/ { print $2 }'`
390 branch=`$GCC_SVN info | sed -ne "/URL:/ {
391 s,.*/trunk,trunk,
392 s,.*/branches/,,
393 s,.*/tags/,,
397 esac
399 rm -f LAST_UPDATED gcc/REVISION
401 date
402 echo "`TZ=UTC date` (revision $revision)"
403 } > LAST_UPDATED
404 echo "[$branch revision $revision]" > gcc/REVISION
406 touch_files_reexec